#include "bibli.h"


float poly(float a, float b, float c, float x){
  return a*x*x+b*x+c;
}

int pee(float x){
  int pex = (int) x;
  if (x >= 0)
    return pex + (pex != x) * 1;
  return pex;
}

int number_root(float a, float b, float c){
  float delta2 =  b*b - 4*a*c;
  if (delta2 > 0.)
    {return 2;}
  else
    return (delta2 == 0.) * 1;
}

float va(float x){//valeur absolue
  return (x >= 0.) ? x : -x;  
}

int _log_entier(int b, float x, bool supto1){
  /*
    Fonction auxiliaire
    supto1 indique si le x d'origine est > 1
    x est supposé > 0
    b est la base du log
   */
  int e = 1, log = 0;
  // équivalent à (!supto1) ? e<x : e<=x ;
  //bool test = (!supto1) ? !(e >= x) : !(e>x) ;
  bool test = !(e >= x);
  while ( test ){
    //printf("      e=%d,log=%d\n",e,log);
    e = b*e;
    log++;
    test = !(e >= x);
  }
  if ( (e == x) && supto1 )
    return log+1;
  return log;
}

int log_entier(int b, float x){
  assert ( x != 0 );
  float vax = va(x);//valeur absolue de x
  if (vax < 1)	      
    return - _log_entier(b,1/vax,false);
  else
    return  _log_entier(b,vax,true) -1;
}

bool is_prime(long x){
  x = (x < 0)? -x:x;
  if ( x * x == x )
    return false;
  long n = 2;
  while (n * n <= x){
    if (x % n == 0){
      return false;}
    n++;
  }
  return true;
}






