#ifndef BIBLI_H
#define BIBLI_H

#include <stdio.h>
#include<unistd.h>
#include <assert.h>
#include <stdbool.h>

// calcule ax^2+bx+c
float poly(float a, float b, float c, float x);

// renvoie le nombre de racines réelle de ax^2+bx+c
int number_root(float a, float b, float c);

// renvoie la partie entière par défaut du log de base b de |x|
int log_entier(int b, float x);

//indique si un nombre est premier 
bool is_prime(long x);

int pee(float x);//partie entière par excès de x

#endif
